<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!--get head from index.html-->
<html>
  <head>
    <title>hut</title>
    <meta name="ROBOTS" content="NOINDEX, NOFOLLOW" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="barium.css" type="text/css">
  </head>
  <body>
    <div class="main">
      <h1 class="title">
        40404040404040404040404
      </h1>
      <div class="padMenu">
        <a href="index.html">home</a>
        <a href="work.html">creations</a>
        <a href="pub">files</a>
      </div>
      <hr />
      <div class="content">
        <!--/get-->
        <h1>boobies.py</h1>
        The most recent version is on <a href="https://github.com/hut/boobies">github</a>.<br />
        <a href="pub/boobies.py">raw</a><br />
        <br />
        <div class="code" style="white-space: pre; font-family:monospace"><!--run highlight -I --inline-css -f --style freya -O html pub/boobies.py--><span style="color:#c2b680">#!/usr/bin/python</span>
<span style="color:#c2b680"># Copyright (C) 2012  Roman Zimbelmann &lt;hut&#64;lavabit.com&gt;</span>
<span style="color:#c2b680"># This software is distributed under the terms of the GNU GPL version 3.</span>
<span style="color:#afe091">&quot;&quot;&quot;</span>
<span style="color:#afe091">boobies.py is a html preprocessor for pre-generated static websites.</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">It searches your html files for commands in the form of &lt;!-- COMMAND [ARGS] --&gt;</span>
<span style="color:#afe091">and evaluates them IN-PLACE.  NESTING COMMANDS IS NOT SUPPORTED.</span>
<span style="color:#afe091">The following commands exist:</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">run:</span>
<span style="color:#afe091">  &lt;!-- run ls -l --&gt;</span>
<span style="color:#afe091">  &lt;!-- /run --&gt;</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">  This will execute &quot;ls -l&quot; in the shell and insert the output into the block</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">get:</span>
<span style="color:#afe091">  You can write this in index.html:</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">    &lt;!-- head --&gt;</span>
<span style="color:#afe091">    &lt;head&gt;&lt;title&gt;boobies&lt;/title&gt;&lt;/head&gt;</span>
<span style="color:#afe091">    &lt;!-- /head --&gt;</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">  and this in another file:</span>
<span style="color:#afe091">    </span>
<span style="color:#afe091">    &lt;!-- get head from index.html --&gt;</span>
<span style="color:#afe091">    foo</span>
<span style="color:#afe091">    &lt;!-- /get --&gt;</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">  and foo will be replaced by &lt;head&gt;&lt;title&gt;boobies&lt;/title&gt;&lt;/head&gt;.</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">relative:</span>
<span style="color:#afe091">  &lt;!-- relative --&gt;</span>
<span style="color:#afe091">  &lt;a href=&quot;about.html&quot;&gt;about&lt;/a&gt;</span>
<span style="color:#afe091">  &lt;!-- /relative --&gt;</span>
<span style="color:#afe091"></span>
<span style="color:#afe091">  If you use this in a &quot;get&quot;-block, it will fix URLs with relative paths.</span>
<span style="color:#afe091">&quot;&quot;&quot;</span>

<span style="color:#e0af91; font-weight:bold">import</span> os<span style="color:#dcdccc">.</span>path
<span style="color:#e0af91; font-weight:bold">import</span> re
<span style="color:#e0af91; font-weight:bold">import</span> sys
<span style="color:#e0af91; font-weight:bold">from</span> subprocess <span style="color:#e0af91; font-weight:bold">import</span> Popen<span style="color:#dcdccc">,</span> PIPE<span style="color:#dcdccc">,</span> call

PATTERN_GET <span style="color:#dcdccc">=</span> r<span style="color:#afe091">'(&lt;!--\s*get\s+(\w+)\s+from\s+([^\s]+)\s*--&gt;\n?)(.*?)(&lt;!--\s*/get\s*--&gt;)'</span>
PATTERN_RUN <span style="color:#dcdccc">=</span> r<span style="color:#afe091">'(&lt;!--\s*run\s+(.*?)\s*--&gt;(\n?))(.*?)(&lt;!--\s*/run\s*--&gt;)'</span>
PATTERN_RELATIVE <span style="color:#dcdccc">=</span> r<span style="color:#afe091">'(&lt;!--\s*relative\s*--&gt;\n?)(.*?)(&lt;!--\s*/relative\s*--&gt;)'</span>
PATTERN_GETURL <span style="color:#dcdccc">=</span> r<span style="color:#afe091">'href=&quot;([^&quot;]+?\.[^&quot;]+?)&quot;'</span>
PATTERN_GETKEYWORD <span style="color:#dcdccc">=</span> r<span style="color:#afe091">'&lt;!--\s*{0}\s*--&gt;\n?(.*?)&lt;!--\s*/{0}\s*--&gt;'</span>

<span style="color:#e0af91; font-weight:bold">def</span> <span style="color:#a6e1ff">main</span><span style="color:#dcdccc">():</span>
  <span style="color:#e0af91; font-weight:bold">if</span> <span style="color:#afe091">'-h'</span> <span style="color:#e0af91; font-weight:bold">in</span> sys<span style="color:#dcdccc">.</span>argv <span style="color:#e0af91; font-weight:bold">or</span> <span style="color:#afe091">'--help'</span> <span style="color:#e0af91; font-weight:bold">in</span> sys<span style="color:#dcdccc">.</span>argv <span style="color:#e0af91; font-weight:bold">or</span> <span style="color:#dabfa5; font-weight:bold">len</span><span style="color:#dcdccc">(</span>sys<span style="color:#dcdccc">.</span>argv<span style="color:#dcdccc">) &lt;=</span> <span style="color:#afe091">1</span><span style="color:#dcdccc">:</span>
    <span style="color:#e0af91; font-weight:bold">return</span> sys<span style="color:#dcdccc">.</span>stdout<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">write</span><span style="color:#dcdccc">(</span><span style="color:#afe091">&quot;usage: boobies.py [--dry] [-h|--help] files...</span><span style="color:#d4b064">\n</span><span style="color:#afe091">&quot;</span><span style="color:#dcdccc">)</span>

  <span style="color:#e0af91; font-weight:bold">for</span> filename <span style="color:#e0af91; font-weight:bold">in</span> <span style="color:#dcdccc">[</span>s <span style="color:#e0af91; font-weight:bold">for</span> s <span style="color:#e0af91; font-weight:bold">in</span> sys<span style="color:#dcdccc">.</span>argv<span style="color:#dcdccc">[</span><span style="color:#afe091">1</span><span style="color:#dcdccc">:]</span> <span style="color:#e0af91; font-weight:bold">if not</span> s<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">startswith</span><span style="color:#dcdccc">(</span><span style="color:#afe091">'-'</span><span style="color:#dcdccc">)]:</span>
    tmpname <span style="color:#dcdccc">=</span> filename <span style="color:#dcdccc">+</span> <span style="color:#afe091">&quot;.__new&quot;</span>

    f <span style="color:#dcdccc">=</span> <span style="color:#dabfa5; font-weight:bold">open</span><span style="color:#dcdccc">(</span>filename<span style="color:#dcdccc">,</span> <span style="color:#afe091">'r'</span><span style="color:#dcdccc">)</span>
    content <span style="color:#dcdccc">=</span> f<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">read</span><span style="color:#dcdccc">()</span>
    f<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">close</span><span style="color:#dcdccc">()</span>
    processed_content <span style="color:#dcdccc">=</span> <span style="color:#a6e1ff">process</span><span style="color:#dcdccc">(</span>content<span style="color:#dcdccc">,</span> filename<span style="color:#dcdccc">)</span>
    <span style="color:#e0af91; font-weight:bold">if</span> processed_content <span style="color:#dcdccc">==</span> content<span style="color:#dcdccc">:</span>
      <span style="color:#e0af91; font-weight:bold">print</span><span style="color:#dcdccc">(</span><span style="color:#afe091">&quot;unchanged: %s&quot;</span> <span style="color:#dcdccc">%</span> filename<span style="color:#dcdccc">)</span>
      <span style="color:#e0af91; font-weight:bold">continue</span>

    tmp <span style="color:#dcdccc">=</span> <span style="color:#dabfa5; font-weight:bold">open</span><span style="color:#dcdccc">(</span>tmpname<span style="color:#dcdccc">,</span> <span style="color:#afe091">&quot;w&quot;</span><span style="color:#dcdccc">)</span>
    tmp<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">write</span><span style="color:#dcdccc">(</span>processed_content<span style="color:#dcdccc">)</span>
    tmp<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">close</span><span style="color:#dcdccc">()</span>
    <span style="color:#a6e1ff">call</span><span style="color:#dcdccc">([</span><span style="color:#afe091">'diff'</span><span style="color:#dcdccc">,</span> <span style="color:#afe091">'-u'</span><span style="color:#dcdccc">,</span> filename<span style="color:#dcdccc">,</span> tmpname<span style="color:#dcdccc">])</span>

    <span style="color:#e0af91; font-weight:bold">if</span> <span style="color:#afe091">'--dry'</span> <span style="color:#e0af91; font-weight:bold">in</span> sys<span style="color:#dcdccc">.</span>argv<span style="color:#dcdccc">:</span>
      os<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">unlink</span><span style="color:#dcdccc">(</span>tmpname<span style="color:#dcdccc">)</span>
    <span style="color:#e0af91; font-weight:bold">else</span><span style="color:#dcdccc">:</span>
      <span style="color:#e0af91; font-weight:bold">print</span><span style="color:#dcdccc">(</span><span style="color:#afe091">&quot;writing: %s&quot;</span> <span style="color:#dcdccc">%</span> filename<span style="color:#dcdccc">)</span>
      os<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">rename</span><span style="color:#dcdccc">(</span>tmpname<span style="color:#dcdccc">,</span> filename<span style="color:#dcdccc">)</span>

<span style="color:#e0af91; font-weight:bold">def</span> <span style="color:#a6e1ff">process</span><span style="color:#dcdccc">(</span>content<span style="color:#dcdccc">,</span> filename<span style="color:#dcdccc">):</span>
  <span style="color:#e0af91; font-weight:bold">global</span> PATH
  PATH <span style="color:#dcdccc">=</span> os<span style="color:#dcdccc">.</span>path<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">dirname</span><span style="color:#dcdccc">(</span>filename<span style="color:#dcdccc">)</span>
  content <span style="color:#dcdccc">=</span> re<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">sub</span><span style="color:#dcdccc">(</span>PATTERN_GET<span style="color:#dcdccc">,</span> _command_get<span style="color:#dcdccc">,</span> content<span style="color:#dcdccc">,</span> <span style="color:#afe091">0</span><span style="color:#dcdccc">,</span> re<span style="color:#dcdccc">.</span>S<span style="color:#dcdccc">)</span>
  content <span style="color:#dcdccc">=</span> re<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">sub</span><span style="color:#dcdccc">(</span>PATTERN_RUN<span style="color:#dcdccc">,</span> _command_run<span style="color:#dcdccc">,</span> content<span style="color:#dcdccc">,</span> <span style="color:#afe091">0</span><span style="color:#dcdccc">,</span> re<span style="color:#dcdccc">.</span>S<span style="color:#dcdccc">)</span>
  <span style="color:#e0af91; font-weight:bold">return</span> content


<span style="color:#e0af91; font-weight:bold">def</span> <span style="color:#a6e1ff">_command_get</span><span style="color:#dcdccc">(</span>m<span style="color:#dcdccc">):</span>
  filename <span style="color:#dcdccc">=</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">3</span><span style="color:#dcdccc">)</span>
  keyword <span style="color:#dcdccc">=</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">2</span><span style="color:#dcdccc">)</span>
  fallback <span style="color:#dcdccc">=</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">4</span><span style="color:#dcdccc">)</span>

  f <span style="color:#dcdccc">=</span> <span style="color:#dabfa5; font-weight:bold">open</span><span style="color:#dcdccc">(</span>filename<span style="color:#dcdccc">,</span> <span style="color:#afe091">'r'</span><span style="color:#dcdccc">)</span>
  content <span style="color:#dcdccc">=</span> f<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">read</span><span style="color:#dcdccc">()</span>
  f<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">close</span><span style="color:#dcdccc">()</span>
  match <span style="color:#dcdccc">=</span> re<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">search</span><span style="color:#dcdccc">(</span>PATTERN_GETKEYWORD<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">format</span><span style="color:#dcdccc">(</span>keyword<span style="color:#dcdccc">),</span> content<span style="color:#dcdccc">,</span> re<span style="color:#dcdccc">.</span>DOTALL<span style="color:#dcdccc">)</span>
  <span style="color:#e0af91; font-weight:bold">if</span> match <span style="color:#e0af91; font-weight:bold">is None</span><span style="color:#dcdccc">:</span>
    sys<span style="color:#dcdccc">.</span>stderr<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">write</span><span style="color:#dcdccc">(</span><span style="color:#afe091">&quot;Could not find keyword {0} in {1}</span><span style="color:#d4b064">\n</span><span style="color:#afe091">&quot;</span><span style="color:#dcdccc">.</span><span style="color:#a6e1ff">format</span><span style="color:#dcdccc">(</span>keyword<span style="color:#dcdccc">,</span> filename<span style="color:#dcdccc">))</span>
    result <span style="color:#dcdccc">=</span> fallback
  <span style="color:#e0af91; font-weight:bold">else</span><span style="color:#dcdccc">:</span>
    result <span style="color:#dcdccc">=</span> re<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">sub</span><span style="color:#dcdccc">(</span>PATTERN_RELATIVE<span style="color:#dcdccc">,</span> _command_relative<span style="color:#dcdccc">,</span> match<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">1</span><span style="color:#dcdccc">),</span> <span style="color:#afe091">0</span><span style="color:#dcdccc">,</span> re<span style="color:#dcdccc">.</span>S<span style="color:#dcdccc">)</span>

  <span style="color:#e0af91; font-weight:bold">return</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">1</span><span style="color:#dcdccc">) +</span> result <span style="color:#dcdccc">+</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">5</span><span style="color:#dcdccc">)</span>


<span style="color:#e0af91; font-weight:bold">def</span> <span style="color:#a6e1ff">_command_relative</span><span style="color:#dcdccc">(</span>m<span style="color:#dcdccc">):</span>
  <span style="color:#e0af91; font-weight:bold">return</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">1</span><span style="color:#dcdccc">) +</span> re<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">sub</span><span style="color:#dcdccc">(</span>PATTERN_GETURL<span style="color:#dcdccc">,</span>
      <span style="color:#e0af91; font-weight:bold">lambda</span> match<span style="color:#dcdccc">:</span> <span style="color:#afe091">'href=&quot;'</span> <span style="color:#dcdccc">+</span> os<span style="color:#dcdccc">.</span>path<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">relpath</span><span style="color:#dcdccc">(</span>match<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">1</span><span style="color:#dcdccc">),</span> PATH<span style="color:#dcdccc">) +</span> <span style="color:#afe091">'&quot;'</span><span style="color:#dcdccc">,</span>
      m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">2</span><span style="color:#dcdccc">)) +</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">3</span><span style="color:#dcdccc">)</span>


<span style="color:#e0af91; font-weight:bold">def</span> <span style="color:#a6e1ff">_command_run</span><span style="color:#dcdccc">(</span>m<span style="color:#dcdccc">):</span>
  output <span style="color:#dcdccc">=</span> <span style="color:#a6e1ff">Popen</span><span style="color:#dcdccc">(</span>m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">2</span><span style="color:#dcdccc">),</span> shell<span style="color:#dcdccc">=</span><span style="color:#e0af91; font-weight:bold">True</span><span style="color:#dcdccc">,</span> stdout<span style="color:#dcdccc">=</span>PIPE<span style="color:#dcdccc">).</span><span style="color:#a6e1ff">communicate</span><span style="color:#dcdccc">()[</span><span style="color:#afe091">0</span><span style="color:#dcdccc">]</span>
  <span style="color:#e0af91; font-weight:bold">if</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">3</span><span style="color:#dcdccc">) !=</span> <span style="color:#afe091">&quot;</span><span style="color:#d4b064">\n</span><span style="color:#afe091">&quot;</span><span style="color:#dcdccc">:</span>
    output <span style="color:#dcdccc">=</span> output<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">strip</span><span style="color:#dcdccc">()</span>
  <span style="color:#e0af91; font-weight:bold">return</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">1</span><span style="color:#dcdccc">) +</span> output<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">decode</span><span style="color:#dcdccc">(</span><span style="color:#afe091">'utf-8'</span><span style="color:#dcdccc">) +</span> m<span style="color:#dcdccc">.</span><span style="color:#a6e1ff">group</span><span style="color:#dcdccc">(</span><span style="color:#afe091">5</span><span style="color:#dcdccc">)</span>


<span style="color:#e0af91; font-weight:bold">if</span> __name__ <span style="color:#dcdccc">==</span> <span style="color:#afe091">'__main__'</span><span style="color:#dcdccc">:</span>
  <span style="color:#a6e1ff">main</span><span style="color:#dcdccc">()</span><!--/run-->
        </div>
        <!--get foot from index.html-->
      </div>
    </div>
  </body>
</html>
<!--/get-->
